# -*- coding: utf-8 -*-
# This file is generated, don't edit it. Edit the files in the scripts/ folder.

from threading import Lock

class Script:
    def __init__(self, script, file_ending, copied = False, file = None, script_instances = None):
        self.script = script
        self.file_ending = file_ending
        self.copied = copied
        self.file = file
        if script_instances == None:
            self.script_instances = []
        else:
            self.script_instances = script_instances
        self.copy_lock = Lock()

scripts = {'rename': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport sys\nimport os\nif len(sys.argv) < 3:\n sys.stderr.write(unicode('Missing script parameters (internal error)').encode('utf-8'))\n exit(1)\ntry:\n os.rename(sys.argv[1], sys.argv[2])\nexcept Exception as e:\n sys.stderr.write(unicode(e).encode('utf-8'))\n exit(2)\nexit(0)", ".py"), 'gcc_versions': Script('#!/bin/sh\n\n/usr/bin/gcc --version\n/usr/bin/g++ --version\n', ".sh"), 'perl_versions': Script('#!/bin/sh\n\n/usr/bin/perl --version\n', ".sh"), 'directory_walk': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport json\nimport os\nimport sys\nimport zlib\nresult = {}\nif len(sys.argv) < 2 or not os.path.isdir(sys.argv[1]):\n sys.stderr.write(unicode('Missing or invalid script parameters (internal error)').encode('utf-8'))\n exit(1)\nbase = sys.argv[1]\ntry:\n for root, directories, files in os.walk(base):\n  relative_root = os.path.relpath(root, base)\n  children = result.setdefault('c', {})\n  if relative_root != '.':\n   for part in relative_root.split('/'):\n    directory = children.setdefault(part, {})\n    children = directory.setdefault('c', {})\n    if 'l' not in directory:\n     directory['l'] = int(os.lstat(root).st_mtime)\n  for filename in files:\n   absolute = os.path.join(root, filename)\n   st = os.lstat(absolute)\n   children[filename] = {'s': st.st_size, 'l': int(st.st_mtime)}\nexcept Exception as e:\n sys.stderr.write(unicode(e).encode('utf-8'))\n exit(2)\nsys.stdout.write(zlib.compress(json.dumps(result, separators=(',', ':'))))\nexit(0)", ".py"), 'fpc_versions': Script('#!/bin/sh\n\n/usr/bin/fpc -i V\n', ".sh"), 'shell_versions': Script('#!/bin/sh\n\n/bin/bash --version\n', ".sh"), 'python_versions': Script('#!/bin/sh\n\n/usr/bin/python2 --version\n/usr/bin/python3 --version\n', ".sh"), 'nodejs_versions': Script('#!/bin/sh\n\n/usr/local/bin/node --version\n', ".sh"), 'settings_network_status': Script('#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport os\nimport json\nimport socket\nimport netifaces\nimport subprocess\nfrom wicd import dbusmanager as wicd_dbusmanager\nfrom wicd import misc as wicd_misc\nreturn_dict = {}\nreturn_dict[\'cstat_hostname\'] = None\nreturn_dict[\'cstat_intf_active\'] = {\'name\': None, \'ip\': None, \'mask\': None}\nreturn_dict[\'cstat_gateway\'] = None\nreturn_dict[\'cstat_dns\'] = None\nreturn_dict[\'cstat_status\'] = None\ntry:\n hname = unicode(socket.gethostname())\n if hname != \'\':\n  return_dict[\'cstat_hostname\'] = hname\nexcept:\n exit(1)\ntry:\n cmd_get_if_ok = "ip route | head -1 | awk -F\' \' \'{print $1}\'"\n ps_get_if_ok = subprocess.Popen(cmd_get_if_ok, shell=True, stdout=subprocess.PIPE)\n intf_ok = ps_get_if_ok.communicate()[0].strip()\n if ps_get_if_ok.returncode:\n  exit(1)\n if intf_ok == \'default\':\n  cmd_get_if_active = "ip route | head -1 | awk -F\' \' \'{print $5}\'"\n  ps_get_if_active = subprocess.Popen(cmd_get_if_active, shell=True, stdout=subprocess.PIPE)\n  intf_active = ps_get_if_active.communicate()[0].strip()\n  if ps_get_if_active.returncode:\n   exit(1)\n else:\n  intf_active = \'\'\n if intf_active != \'\':\n  return_dict[\'cstat_intf_active\'][\'name\'] = intf_active\n  intf_addrs = netifaces.ifaddresses(intf_active)\n  if netifaces.AF_INET in intf_addrs and \'addr\' in intf_addrs[netifaces.AF_INET][0] and \'netmask\' in intf_addrs[netifaces.AF_INET][0]:\n   return_dict[\'cstat_intf_active\'][\'ip\'] = intf_addrs[netifaces.AF_INET][0][\'addr\']\n   return_dict[\'cstat_intf_active\'][\'mask\'] = intf_addrs[netifaces.AF_INET][0][\'netmask\']\n gws = netifaces.gateways()\n if \'default\' in gws and netifaces.AF_INET in gws[\'default\']:\n  return_dict[\'cstat_gateway\'] = gws[\'default\'][netifaces.AF_INET][0]\nexcept:\n exit(1)\ntry:\n with open(\'/etc/resolv.conf\', \'r\') as rcf:\n  lines = rcf.readlines()\n  for i, l in enumerate(lines):\n   l_splitted = l.split(\' \')\n   if l_splitted[0] == \'nameserver\' and l_splitted[1] != \'\':\n    return_dict[\'cstat_dns\'] = l_splitted[1]\n    break\nexcept:\n return_dict[\'cstat_dns\'] = None\ntry:\n wicd_dbusmanager.connect_to_dbus()\n status = wicd_dbusmanager.get_dbus_ifaces()[\'daemon\'].GetConnectionStatus()\n if status[0] == wicd_misc.NOT_CONNECTED:\n  return_dict[\'cstat_status\'] = \'Not connected\'\n elif status[0] == wicd_misc.CONNECTING:\n  return_dict[\'cstat_status\'] = \'Connecting ({0})...\'.format(status[1][0][0].upper() + status[1][0][1:])\n elif status[0] == wicd_misc.WIRELESS or status == wicd_misc.WIRED:\n  return_dict[\'cstat_status\'] = \'Connected\'\n elif status[0] == wicd_misc.SUSPENDED:\n  return_dict[\'cstat_status\'] = \'Suspended\'\n else:\n  return_dict[\'cstat_status\'] = \'Unknown ({0})\'.format(status[0])\nexcept:\n return_dict[\'cstat_status\'] = \'None\'\nprint json.dumps(return_dict)', ".py"), 'logs_list': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport json\nimport os\nimport stat\nimport sys\nimport zlib\nresult = {}\nif len(sys.argv) < 2 or not os.path.isdir(sys.argv[1]):\n sys.stderr.write(unicode('Missing or invalid script parameters (internal error)').encode('utf-8'))\n exit(1)\nbase = sys.argv[1]\ntry:\n for name in os.listdir(base):\n  if not name.endswith('_stdout.log') and not name.endswith('_stderr.log'):\n   continue\n  st = os.lstat(os.path.join(base, name))\n  if stat.S_ISREG(st.st_mode):\n   result[name] = st.st_size\nexcept Exception as e:\n sys.stderr.write(unicode(e).encode('utf-8'))\n exit(2)\nsys.stdout.write(zlib.compress(json.dumps(result, separators=(',', ':'))))\nexit(0)", ".py"), 'versions_main': Script('#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport os\nimport re\nBINDINGS_DIR = "/usr/tinkerforge/bindings/"\nBINDINGS = ["csharp", "c", "delphi", "java", "javascript", "matlab", "perl", "php", "python", "ruby", "shell", "vbnet"]\ndef get_changelog_version(bindings_root_directory):\n r = re.compile(\'^(\\d+)\\.(\\d+)\\.(\\d+):\')\n last = None\n for line in file(os.path.join(bindings_root_directory, \'changelog.txt\'), \'rb\').readlines():\n  m = r.match(line)\n  if m is not None:\n   last = (m.group(1), m.group(2), m.group(3))\n return last\nos.system(\'/usr/bin/brickd --version\')\nos.system(\'/usr/bin/redapid --version\')\nos.system(\'/bin/cat /etc/tf_image_version\')\nfor b in BINDINGS:\n try:\n  path = os.path.join(BINDINGS_DIR, b)\n  print \'.\'.join(get_changelog_version(path))\n except:\n  print \'Unknown\'', ".py"), 'php_versions': Script('#!/bin/sh\n\n/usr/bin/php --version\n', ".sh"), 'ruby_versions': Script('#!/bin/sh\n\n/usr/bin/ruby --version\n', ".sh"), 'settings_network_wireless_scan': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport json\nimport subprocess\nfrom sys import argv\nif len(argv) < 2:\n exit (1)\niname = unicode(argv[1])\nreturn_dict = None\nwlscan_cmd = '/sbin/ifconfig '+iname+' up && /usr/sbin/service wicd restart &&              /bin/sleep 3 && /usr/bin/wicd-cli --wireless -Sl && :'\nwlscan_ps = subprocess.Popen(wlscan_cmd, shell=True, stdout=subprocess.PIPE)\nwlscan_output = wlscan_ps.communicate()[0]\nif wlscan_ps.returncode:\n exit(1)\n_lines = wlscan_output.splitlines()\nif wlscan_output and len(_lines) > 0:\n return_dict = {}\n for l in _lines:\n  lsplitted = l.split('\\t')\n  if len(lsplitted) == 1:\n   continue\n  _apdict = {'essid': lsplitted[0], 'bssid': lsplitted[1], 'channel': lsplitted[2]}\n  return_dict[lsplitted[3]] = _apdict\n for key, value in return_dict.iteritems():\n  netdetail_cmd = '/usr/bin/wicd-cli --wireless -n'+key+' -d'\n  netdetail_ps = subprocess.Popen(netdetail_cmd, shell=True, stdout=subprocess.PIPE)\n  netdetail_output = netdetail_ps.communicate()[0]\n  if netdetail_ps.returncode:\n   exit(1)\n  lines = netdetail_output.split('\\n')\n  for l in lines:\n   lsplitted = l.split(': ')\n   if lsplitted[0] == 'Encryption':\n    return_dict[key]['encryption'] = lsplitted[1]\n   elif lsplitted[0] == 'Encryption Method':\n    return_dict[key]['encryption_method'] = lsplitted[1]\nprint json.dumps(return_dict, separators=(',', ':'))", ".py"), 'program_delete_logs': Script('#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport os\nimport json\nfrom sys import argv\nif len(argv) < 2:\n print json.dumps(False)\n exit (0)\nfile_list = json.loads(argv[1])\nif not isinstance(file_list, list):\n print json.dumps(False)\n exit(0)\nif len(file_list) <= 0:\n print json.dumps(False)\n exit(0)\nfor f in file_list:\n try:\n  os.remove(f)\n except:\n  print json.dumps(False)\n  exit(0)\nprint json.dumps(True)', ".py"), 'program_delete_files_dirs': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport os\nimport json\nimport shutil\nimport sys\nif len(sys.argv) < 3:\n sys.stderr.write(unicode('Missing script parameters (internal error)').encode('utf-8'))\n exit(1)\ntry:\n file_list = json.loads(sys.argv[1])\n dir_list = json.loads(sys.argv[2])\nexcept Exception as e:\n sys.stderr.write(unicode(e).encode('utf-8'))\n exit(2)\nif not isinstance(file_list, list) or not isinstance(dir_list, list):\n sys.stderr.write(unicode('Invalid script parameters (internal error)').encode('utf-8'))\n exit(1)\nfor file_path in file_list:\n if os.path.exists(file_path):\n  try:\n   os.remove(file_path)\n  except Exception as e:\n   sys.stderr.write(unicode(e).encode('utf-8'))\n   exit(2)\nfor dir_path in dir_list:\n if os.path.isdir(dir_path):\n  try:\n   shutil.rmtree(dir_path)\n  except Exception as e:\n   sys.stderr.write(unicode(e).encode('utf-8'))\n   exit(2)\nexit(0)", ".py"), 'settings_time_get': Script('#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport time\ndef time_utc_offset():\n if time.localtime(time.time()).tm_isdst and time.daylight:\n  return -time.altzone/(60*60)\n return -time.timezone/(60*60)\nprint int(time.time())\nprint time_utc_offset()', ".py"), 'fpcmake_helper': Script('#!/bin/sh -e\n\nexport PATH=/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin\nexport FPCDIR=/usr/lib/fpc/`ls /usr/lib/fpc/ | grep -E [0-9].[0-9].[0-9] | head -n1`\n\ncd $1\nshift\nfpcmake\nmake $@\n', ".sh"), 'settings_network_get_interfaces': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport os\nimport sys\nimport json\nimport netifaces\nimport subprocess\nreturn_dict = {'wireless': None, 'wired': None, 'wireless_links': None}\nwl_links_dict = {}\nlwireless = []\nlwired = []\nfor intf in netifaces.interfaces():\n if os.path.isdir('/sys/class/net/'+intf+'/wireless'):\n  lwireless.append(intf)\n else:\n  lwired.append(intf)\nif len(lwireless) > 0:\n return_dict['wireless'] = lwireless\n for wl_intf in lwireless:\n  cmd_get_link = '/sbin/iwconfig '+wl_intf+' | /usr/bin/head -n2'\n  ps_get_link = subprocess.Popen(cmd_get_link, shell=True, stdout=subprocess.PIPE)\n  cmd_output = ps_get_link.communicate()[0]\n  if ps_get_link.returncode:\n   exit (1)\n  wl_links_dict[wl_intf] = {'name': wl_intf, 'status': False, 'essid': None, 'bssid': None}\n  cmd_output_lines = cmd_output.splitlines()\n  if len(cmd_output_lines) >= 2 and cmd_output:\n   if 'off/any' in cmd_output_lines[0] or 'unassociated' in cmd_output_lines[0]:\n    continue\n   cmd_output_line0_array = cmd_output_lines[0].split(' ')\n   cmd_output_line1_array = cmd_output_lines[1].split('Access Point: ')\n   if len(cmd_output_line0_array) >= 0:\n    for token in cmd_output_line0_array:\n     if 'ESSID:' in token:\n      _associated_essid = token.split(':')[1]\n      associated_essid = _associated_essid[1:-1]\n      if len(cmd_output_line1_array) > 0:\n       associated_bssid = cmd_output_line1_array[-1:]\n       wl_links_dict[wl_intf] = {'name': wl_intf, 'status': True, 'essid': associated_essid, 'bssid': associated_bssid}\nlwired = [x for x in lwired if x!='lo' and x!='tunl0']\nif len(lwired) > 0:\n return_dict['wired'] = lwired\nif len(wl_links_dict) > 0:\n return_dict['wireless_links'] = wl_links_dict\nprint json.dumps(return_dict, separators=(',', ':'))", ".py"), 'octave_versions': Script('#!/bin/sh\n\n/usr/bin/octave --version\n', ".sh"), 'settings_network_apply': Script("#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport os\nfrom sys import argv\nif len(argv) < 3:\n exit (1)\niname = unicode(argv[1])\nitype = unicode(argv[2])\nif itype == 'wireless':\n netidx = unicode(argv[3])\n cmd_wireless = '/sbin/ifconfig '+iname+' up &&                    /usr/sbin/service wicd restart &&                    /bin/sleep 3 && /usr/bin/wicd-cli --wireless -c -n'+netidx+' && :'\n cmd_wireless_code = os.system(cmd_wireless)\n if cmd_wireless_code:\n  exit (1)\nelif itype == 'wired':\n cmd_wired = '/sbin/ifconfig '+iname+' up &&                 /usr/sbin/service wicd restart &&                 /bin/sleep 3 && /usr/bin/wicd-cli --wired -c -n0 && :'\n cmd_wired_code = os.system(cmd_wired)\n if cmd_wired_code:\n  exit (1)\nelse:\n exit (1)", ".py"), 'java_versions': Script('#!/bin/sh\n\n/usr/bin/java -version\n\n', ".sh"), 'make_helper': Script('#!/bin/sh -e\n\nexport PATH=/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin\n\ncd $1\nshift\nmake $@\n', ".sh"), 'mono_versions': Script('#!/bin/sh\n\n/usr/bin/mono --version\n', ".sh"), 'restart_brickd': Script('#!/bin/sh\n\n/etc/init.d/brickd restart\n', ".sh"), 'overview': Script('#!/usr/bin/env python2\n# -*- coding: utf-8 -*-\nimport psutil\nimport sys\nimport json\nwith open("/proc/uptime", "r") as utf:\n print utf.readline().split(".")[0]\ndu = psutil.disk_usage("/")\nall_process_info = []\nfor p in psutil.process_iter():\n p.get_cpu_percent(interval=0)\nif len(sys.argv) < 2:\n print psutil.cpu_percent(1)\nelse:\n print psutil.cpu_percent(float(sys.argv[1]))\nall_process_info = []\nfor p in psutil.process_iter():\n process_dict = {\'cmd\': p.name, \'pid\': p.pid, \'usr\': p.username, \'cpu\': int(p.get_cpu_percent(interval=0) * 10), \'mem\': int(p.get_memory_percent() * 10)}\n all_process_info.append(process_dict)\nprint psutil.used_phymem()\nprint psutil.TOTAL_PHYMEM\nprint du.used\nprint du.total\ninterfaces = psutil.network_io_counters(pernic=True)\nif \'tunl0\' in interfaces:\n del interfaces[\'tunl0\']\nprint json.dumps(interfaces, separators=(\',\', \':\'))\nprint json.dumps(all_process_info, separators=(\',\', \':\'))', ".py"), 'restart_reboot_shutdown': Script('#!/bin/sh\n\nif [ $# -eq 0 ]\n  then\n    echo "No arguments supplied"\n    exit 1\nfi\n\nif [ $1 -eq 0 ]\n  then\n    /etc/init.d/brickd restart\nfi\n\nif [ $1 -eq 1 ]\n  then\n    init 6\n#   reboot\nfi\n\nif [ $1 -eq 2 ]\n  then\n    halt\nfi\n', ".sh")}